Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreFrameListenerMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreFrameListenerMode.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/OBA/OBAOgreFrameListenerMode.h	(revision 751)
@@ -74,4 +74,6 @@
 
 	virtual void destroyScene(void);    // Optional to override this
+
+	unsigned int getHandle();
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCSampleConfigFile.h	(revision 751)
@@ -50,15 +50,27 @@
 	Ogre::String getEntityClustersFolder();
 
-	bool getEntityClustersMergedClusters();
-
 	bool getEntityClustersSplittedClusters();
 
-	Ogre::String getEntityClustersMergedMeshName();
+	bool getEntityClustersGroupedClusters();
+
+	bool getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasDebug();
+
+	bool getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasDebug();
+
+	bool getBillboardCloudIndirectGroupedBillboardsTextureAtlasDebug();
+
+	bool getBillboardCloudIndirectMergedBillboardsTextureAtlasDebug();
+
+	Ogre::String getEntityClustersGroupedMeshName();
 
 	Ogre::String getEntityClustersSplittedMeshName();
 
-	Ogre::String getEntityClustersMergedMaterialName();
+	Ogre::String getEntityClustersGroupedMaterialName();
 
 	Ogre::String getEntityClustersSplittedMaterialName();
+
+	Ogre::String getEntityClustersGroupedTextureUnit0Name();
+
+	Ogre::String getEntityClustersSplittedTextureUnit0Name();
 
 	bool getBillboardCloudMergedBillboards();
@@ -94,4 +106,8 @@
 	Ogre::String getBillboardCloudMergedXMLName();
 
+	Ogre::String getBillboardCloudIndirectPointMeshName();
+
+	Ogre::String getBillboardCloudIndirectPointMaterialName();
+
 	unsigned int getBillboardCloudGroups();
 
@@ -102,5 +118,5 @@
 	Ogre::String getBillboardCloudDiffuseColorEntityTextureName();
 
-	Ogre::String getBillboardCloudDiffuseColorEntityTextureAtlasName();
+	Ogre::String getBillboardCloudDiffuseColorEntityTextureAtlasName();	
 
 	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasBitRange();
@@ -108,17 +124,17 @@
 	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasSize();
 
-	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureSize();
+	unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureSize();
 
-	bool getBillboardCloudIndirectBillboardGroupTextureAtlasGeneration();
+	bool getBillboardCloudIndirectGroupedBillboardsTextureAtlasGeneration();
 
-	Ogre::String getBillboardCloudIndirectBillboardGroupTextureAtlasName();
+	Ogre::String getBillboardCloudIndirectGroupedBillboardsTextureAtlasName();
 
-	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasBitRange();
+	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureAtlasBitRange();
 
-	unsigned int getBillboardCloudIndirectBillboardGroupTextureAtlasSize();
+	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureAtlasSize();
 
-	unsigned int getBillboardCloudIndirectBillboardGroupTextureSize();
+	unsigned int getBillboardCloudIndirectGroupedBillboardsTextureSize();
 
-	bool getBillboardCloudDiffuseColorBillboardGroupTextureAtlasGeneration();
+	bool getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasGeneration();
 
 	bool getBillboardCloudDiffuseColorMergedBillboardsTextureAtlasGeneration();
@@ -132,5 +148,5 @@
 	unsigned int getBillboardCloudDiffuseColorMergedBillboardsTextureSize();
 
-	unsigned int getBillboardCloudDiffuseColorBillboardGroupTextureAtlasSize();
+	unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasSize();
 
 	unsigned int getBillboardCloudDiffuseColorEntityTextureAtlasNumSamples();
@@ -138,7 +154,11 @@
 	bool getBillboardCloudIndirectMergedBillboardsTextureAtlasGeneration();
 
+	Ogre::String getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasName();
+
 	Ogre::String getBillboardCloudIndirectMergedBillboardsTextureAtlasName();
 
 	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasBitRange();
+
+	unsigned int getBillboardCloudDiffuseColorGroupedBillboardsTextureAtlasBitRange();
 
 	unsigned int getBillboardCloudIndirectMergedBillboardsTextureAtlasSize();
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCManager.h	(revision 751)
@@ -69,4 +69,5 @@
 	void loadBillboardCloudMergedXML();
 
+	void saveBillboardCloudIndirectSplittedPointMeshName();
 
   protected:
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCLeafDistributionGenerator.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCLeafDistributionGenerator.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCLeafDistributionGenerator.h	(revision 751)
@@ -16,4 +16,6 @@
     virtual ~LeafDistributionGenerator();
 
+	void generateAverageLeafPosition(Leaf *leaf);
+
 	void generateAverageLeafNormal(Leaf *leaf);
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCClusterViewMode.h	(revision 751)
@@ -13,4 +13,5 @@
 		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
 		{
+			showDebugOverlay(false);
 		}
 
@@ -19,10 +20,30 @@
 		}
 
+		bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
+		{
+			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));
+
+			return OgreFrameListenerMode::frameStarted(evt, inputReader);	
+		}
+
+		void setEntityClustersMeshName(Ogre::String entityClustersMeshName)
+		{
+			mEntityClustersMeshName = entityClustersMeshName;
+		}
+
 		virtual void createScene()
 		{
+			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));
+
 			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
-			Ogre::Entity* emesh = mSceneMgr->createEntity("chestnutLeavesEntitySample.mesh", "chestnutLeavesEntitySample.mesh");		
-			sNode->attachObject(emesh);
+			//Ogre::Entity* eLeafClustersGrouped = mSceneMgr->createEntity(mEntityClustersMeshName, mEntityClustersMeshName);					
+			Ogre::Entity* eLeafClustersGrouped = mSceneMgr->createEntity("chestnutLeafClustersGrouped.mesh", "chestnutLeafClustersGrouped.mesh");								
+			sNode->attachObject(eLeafClustersGrouped);			
+			sNode->rotate(Ogre::Vector3::UNIT_X, Ogre::Radian(Ogre::Degree(-90.0)));
 		}
+	protected:
+		Ogre::String mEntityClustersMeshName;
+
+
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCEntityTextureAtlasViewMode.h	(revision 751)
@@ -40,6 +40,4 @@
 		virtual ~EntityTextureAtlasViewMode();		
 
-		unsigned int nextPowerOf2(unsigned int nPlanes);
-
 		virtual bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader);
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardViewMode.h	(revision 751)
@@ -13,4 +13,6 @@
 		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
 		{
+			showDebugOverlay(false);
+			mReloadedTextures = false;
 		}
 
@@ -19,11 +21,47 @@
 		}
 
+		bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
+		{
+			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));
+
+			//if (!mReloadedTextures)
+			//{
+			//	for (unsigned int iSubEntity = 0; iSubEntity < mBillboardCloudEntity->getNumSubEntities(); iSubEntity++)
+			//	{
+			//		Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().getByName(mBillboardCloudEntity->getSubEntity(iSubEntity)->getMaterialName());
+			//		Ogre::LogManager::getSingleton().logMessage("Reloading texture:" + materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->getTextureName());
+
+			//		Ogre::TexturePtr texturePtr = Ogre::TextureManager::getSingleton().getByName(materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->getTextureName());
+			//		texturePtr->reload();
+			//		materialPtr->reload();
+			//	}
+			//	mReloadedTextures = true;
+			//}
+
+			return OgreFrameListenerMode::frameStarted(evt, inputReader);	
+		}
+
+		void setBillboardCloudMeshName(Ogre::String billboardCloudMeshName)
+		{
+			mBillboardCloudMeshName = billboardCloudMeshName;
+		}
+
 		virtual void createScene()
 		{
+			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));
+
 			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
-			Ogre::Entity* emesh = mSceneMgr->createEntity("chestnutLeavesBillboardCloudMerged.mesh","chestnutLeavesBillboardCloudGrouped.mesh");		
-			sNode->attachObject(emesh);
+			//mBillboardCloudEntity = mSceneMgr->createEntity(mBillboardCloudMeshName, mBillboardCloudMeshName);		
+			mBillboardCloudEntity = mSceneMgr->createEntity("chestnutLeavesBillboardCloudGrouped.mesh", "chestnutLeavesBillboardCloudGrouped.mesh");		
+			sNode->attachObject(mBillboardCloudEntity);
+			sNode->rotate(Ogre::Vector3::UNIT_X, Ogre::Radian(Ogre::Degree(-90.0)));
 		}
 
+	protected:
+		Ogre::String mBillboardCloudMeshName;
+
+		Ogre::Entity *mBillboardCloudEntity;
+
+		bool mReloadedTextures;
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardCloudTextureViewMode.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardCloudTextureViewMode.h	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/LBBC/LBBCBillboardCloudTextureViewMode.h	(revision 751)
@@ -22,11 +22,11 @@
 	unsigned int mSubEntityVisible;
 
-	Ogre::Entity *mEntity;
+	Ogre::Entity *mEntityClusters;
 
 public:
 	
-	void setEntity(Ogre::Entity *entity)
+	void setEntityClusters(Ogre::Entity *entity)
 	{
-		mEntity = entity;
+		mEntityClusters = entity;
 	}
 
@@ -50,8 +50,4 @@
 		if (mCurrentTexture < mNumTextures)
 		{
-			//calculateProjectionMatrix(unsigned int iSubEntity, Ogre::Camera *cam);
-			//initializeShaderParameters(unsigned int iSubEntity);
-			mTexture->getRectangle2D()->setVisible(false);
-			mTextureAtlas->getRectangle2D()->setVisible(false);
 		}
     }
@@ -76,5 +72,4 @@
 	void preRenderTargetUpdate(const Ogre::RenderTargetEvent& evt)
     {
-		//configureTexture( unsigned int iSubEntity );
     }
 
@@ -90,7 +85,11 @@
 		unsigned int mFrame;
 
-		Ogre::SceneNode *mClusterizedEntitiesMergedSceneNode;
+		Ogre::SceneNode *mEntityClustersGroupedSceneNode;
 		
-		Ogre::Entity *mClusterizedEntities;
+		Ogre::SceneNode *mBillboardCloudSplittedSceneNode;
+
+		Ogre::Entity *mEntityClustersGrouped;
+
+		Ogre::Entity *mBillboardCloudSplitted;
 
 		ClusterTextureListener mClusterTextureListener;
@@ -120,9 +119,23 @@
 		Ogre::String mTextureAtlasFolder;
 
-		Ogre::String mEntityName;
+		Ogre::String mEntityClustersGroupedName;
+
+		Ogre::String mBillboardCloudSplittedName;
+
+		Ogre::Matrix4 mCustomProjMatrix;
+
+		Ogre::String mTextureName;
+
+		bool mDebugBillboardGeneration;
+
+		bool mDebugTextureAtlasGeneration;
+
+		unsigned int mCurrentBillboardGroup;
+
+		unsigned int mCurrentBillboard;
 
 	public:
 
-		BillboardCloudTextureViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false);
+		BillboardCloudTextureViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false);	
 
 		virtual ~BillboardCloudTextureViewMode();		
@@ -133,4 +146,22 @@
 
 		virtual void destroyScene();
+
+		void setBillboardCloudGroupedTextureAtlasDebug(bool debugTextureAtlasGeneration);
+
+		void setTextureName(Ogre::String textureName);
+
+		void configureBillboard();
+
+		void enableEntityClusterCustomOrthogonalCameraMaterial(unsigned int iEntityClusterGrouped);
+
+		void disableEntityClusterCustomOrthogonalCameraMaterial(unsigned int iEntityClusterGrouped);
+
+		void configureTexture();
+
+		void configureTextureAtlas();
+	
+		bool processUnbufferedKeyInput(const Ogre::FrameEvent& evt);
+
+		void saveTextureAtlas();
 		
 		void setTextureAtlasSize(unsigned int size);
@@ -138,5 +169,7 @@
 		void setTextureSize(unsigned int size);
 
-		void setEntityName(Ogre::String entityName);
+		void setEntityClustersGroupedName(Ogre::String entityClustersGrouped);
+
+		void setBillboardCloudSplittedName(Ogre::String billboardCloudSplittedName);
 
 		void setTextureAtlasName(Ogre::String textureAtlasName);
@@ -145,4 +178,15 @@
 
 		void setTextureAtlasBitRange(unsigned int bitRange);
+
+		void configureBillboardOrthogonalAlignedCamera(unsigned int iBillboard);
+
+		void initializeEntityClustersGrouped();
+
+		void initializeBillboardCloudSplitted();
+		
+		void generateTexture();
+
+		void generateTextureAtlas();
+
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCSubEntity.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCSubEntity.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCSubEntity.h	(revision 751)
@@ -130,6 +130,4 @@
 	void setMaterialName(Ogre::String value);
 
-	//void createUniqueVertices();
-
 	UniqueVertexList* getUniqueVertices();
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardClusterData.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardClusterData.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardClusterData.h	(revision 751)
@@ -77,5 +77,5 @@
 	Ogre::Vector2 getBillboardUVMapMin(unsigned int iBillboardGroup);
 
-	void addBillboardUVMapMin(Ogre::Vector2 min);
+	void addBillboardUVMapMin(Ogre::Vector2 minVec);
 
 	void removeBillboardUVMapMin(unsigned int iBillboardGroup);
@@ -83,5 +83,5 @@
 	Ogre::Vector2 getBillboardUVMapMax(unsigned int iBillboardGroup);
 
-	void addBillboardUVMapMax(Ogre::Vector2 max);
+	void addBillboardUVMapMax(Ogre::Vector2 maxVec);
 
 	void removeBillboardUVMapMax(unsigned int iBillboardGroup);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudGenerator.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudGenerator.h	(revision 721)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudGenerator.h	(revision 751)
@@ -2,5 +2,4 @@
 #define _BBCBILLBOARDCLOUDGENERATOR_H
 
-#include <BBCUtil.h>
 #include <BBCEntity.h>
 #include <BBCEntityDistribution.h>
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudUVMapper.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudUVMapper.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCBillboardCloudUVMapper.h	(revision 751)
@@ -46,5 +46,5 @@
     void generateTextureAtlasTextureCoords(bool mergeBillboards, bool groupedBillboards = false, unsigned int numberGroups = 1);
 
-	void addTextureAtlasTextureCoords(bool mergeBillboards, bool groupedBillboards, unsigned int numGeneratedBillboardClouds, unsigned int iBillboardGroup, unsigned int iBillboard);
+	void addTextureAtlasTextureCoords(bool mergeBillboards, bool groupedBillboards, unsigned int numGeneratedBillboardClouds, unsigned int iBillboardGroup, unsigned int iBillboard, unsigned int iBillboardInGroup);
 
     void setBillboardCloud(BillboardCloud *billboardCloud);
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCManager.h	(revision 751)
@@ -3,4 +3,5 @@
 
 #include <BBCPrerequisites.h>
+#include <BBCUtil.h>
 #include <BBCSingleton.h>
 
@@ -31,10 +32,4 @@
 	void shutdown(void);
 
-	Ogre::MeshSerializer* getMeshSerializer(void);
-
-	Ogre::XMLMeshSerializer* getXMLMeshSerializer(void);
-
-  protected:
-
 };
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCUtil.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCUtil.h	(revision 700)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/BBC/BBCUtil.h	(revision 751)
@@ -5,4 +5,36 @@
 
 namespace BBC {
+
+class _BBCExport Util
+{
+public:
+	static Ogre::String getBaseName(Ogre::String fileName)
+	{
+		Ogre::String baseName;
+		size_t pos = fileName.find_last_of(".");
+		baseName = fileName.substr(0, pos);
+		return baseName;
+	}
+
+	static Ogre::String getExtensionName(Ogre::String fileName)
+	{
+		Ogre::String ext;
+		size_t pos = fileName.find_last_of(".");
+		ext = fileName.substr(pos+1);
+		return ext;
+	}
+
+	static unsigned int nextPowerOf2(unsigned int nPlanes)
+	{
+		unsigned int depth = 1;
+		while (depth < nPlanes)
+		{
+			depth = depth << 1;
+		}
+		return depth;
+	}
+
+};
+
 /*
 extern "C" _BBCExport double fround(double n, unsigned d)
@@ -15,16 +47,4 @@
       return (int)floor(x + 0.5);
 }
-
-extern "C" _BBCExport unsigned int getUpperPowerOfTwo(unsigned int powerOfTwo)
-{
-	unsigned int icount = 0;
-	unsigned int depth = 1;
-	while (icount < powerOfTwo)
-	{
-		depth = depth << 1;
-		icount++;
-	}
-	return depth;
-}
 */
 }
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGUtil.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGUtil.h	(revision 751)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGUtil.h	(revision 751)
@@ -0,0 +1,52 @@
+#ifndef _IMGUTIL_H
+#define _IMGUTIL_H
+
+#include <IMGPrerequisites.h>
+
+namespace IMG {
+
+class _IMGExport Util
+{
+public:
+	static Ogre::String getBaseName(Ogre::String fileName)
+	{
+		Ogre::String baseName;
+		size_t pos = fileName.find_last_of(".");
+		baseName = fileName.substr(0, pos);
+		return baseName;
+	}
+
+	static Ogre::String getExtensionName(Ogre::String fileName)
+	{
+		Ogre::String ext;
+		size_t pos = fileName.find_last_of(".");
+		ext = fileName.substr(pos+1);
+		return ext;
+	}
+
+	static unsigned int nextPowerOf2(unsigned int nPlanes)
+	{
+		unsigned int depth = 1;
+		while (depth < nPlanes)
+		{
+			depth = depth << 1;
+		}
+		return depth;
+	}
+
+};
+
+/*
+extern "C" _BBCExport double fround(double n, unsigned d)
+{ 
+	return floor(n * pow((double)10.,(int) d) + .5) / pow((double)10.,(int) d);
+}
+
+extern "C" _BBCExport int iround(double x)
+{
+      return (int)floor(x + 0.5);
+}
+*/
+}
+
+#endif
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTexture.h	(revision 751)
@@ -55,5 +55,7 @@
 	 void setRenderTargetListener(Ogre::RenderTargetListener *renderTargetListener);
 
-	 virtual void create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera);
+	 virtual void debug();
+
+	 virtual void create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera, Ogre::ColourValue backgroundColour);
 
 	 Ogre::ColourValue getAvgColour();
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/include/IMG/IMGTextureAtlas.h	(revision 751)
@@ -3,4 +3,5 @@
 
 #include <IMGPrerequisites.h>
+#include <IMGUtil.h>
 #include <IMGTexture.h>
 
@@ -51,5 +52,5 @@
 	void debug();
 
-	void create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera);
+	void create(Ogre::String fileName, unsigned int width, unsigned int height, Ogre::PixelFormat pixelFormat, Ogre::Camera *camera, Ogre::ColourValue backgroundColour);
 
 	void update();
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 745)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGenerator.vcproj	(revision 751)
@@ -30,4 +30,5 @@
 				BufferSecurityCheck="TRUE"
 				EnableFunctionLevelLinking="TRUE"
+				DisableLanguageExtensions="FALSE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
@@ -83,4 +84,5 @@
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
 				RuntimeLibrary="2"
+				DisableLanguageExtensions="FALSE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/scripts/IBRBillboardCloudTreeGeneratorCommandLine.vcproj	(revision 751)
@@ -25,4 +25,5 @@
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
+				DisableLanguageExtensions="FALSE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
@@ -73,4 +74,5 @@
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
 				RuntimeLibrary="0"
+				DisableLanguageExtensions="FALSE"
 				UsePrecompiledHeader="0"
 				WarningLevel="3"
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp	(revision 731)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/OBAOgreFrameListener.cpp	(revision 751)
@@ -156,6 +156,5 @@
 	mDefaultOgreFrameListenerMode = getFrameListenerMode(iOgreFrameListenerMode);
 	Ogre::Root::getSingleton()._setCurrentSceneManager(mDefaultOgreFrameListenerMode->getSceneManager());
-	mWindow->removeAllViewports();
-	mWindow->addViewport(mDefaultOgreFrameListenerMode->getCamera());
+	mWindow->getViewport(0)->setCamera(mDefaultOgreFrameListenerMode->getCamera());	
 }
 
Index: /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp
===================================================================
--- /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp	(revision 747)
+++ /GTP/trunk/Lib/Illum/IBRBillboardCloudTrees/OGRE/src/LBBCEntityTextureAtlasViewMode.cpp	(revision 751)
@@ -10,5 +10,5 @@
 	mTextureAtlasGenerated = false;
 	mFrame = 0;
-	mDebugOverlay->setScale(0.0, 0.0);
+	showDebugOverlay(false);
 }
 
@@ -49,17 +49,16 @@
 }
 
-unsigned int EntityTextureAtlasViewMode::nextPowerOf2(unsigned int nPlanes)
-{
-	unsigned int depth = 1;
-	while (depth < nPlanes)
-	{
-		depth = depth << 1;
-	}
-	return depth;
-}
-
 bool EntityTextureAtlasViewMode::frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
 {
+	mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(1.0, 1.0, 1.0, 1.0));
+
 	if (mFrame == 1)
+	{
+		mTextureAtlas->getTextureAtlasSceneNode()->setVisible(false);
+		mTextureAtlas->update();
+		mTextureAtlas->getTextureAtlasSceneNode()->setVisible(true);
+	}
+	
+	if (mFrame == 2)
 	{
 		if (!mTextureAtlasGenerated)
@@ -93,4 +92,9 @@
 void EntityTextureAtlasViewMode::createScene()
 {
+	IMG::TexturePtr texturePtr ( new IMG::Texture() );
+	texturePtr->bind(mTextureName);
+	Ogre::ColourValue avgColour = texturePtr->getAvgColour();
+	mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(1.0, 1.0, 1.0, 1.0)); 
+
 	mTextureAtlasNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
 	mTextureAtlas = IMG::TextureAtlasPtr( new IMG::TextureAtlas() );
@@ -109,5 +113,5 @@
 	}
 
-	mTextureAtlas->create(mTextureAtlasName, mTextureAtlasSize, mTextureAtlasSize, mSrcPixelFormat, mCamera);
+	mTextureAtlas->create(mTextureAtlasName, mTextureAtlasSize, mTextureAtlasSize, mSrcPixelFormat, mCamera, avgColour);
 	mTextureAtlas->setTextureAtlasSceneNode(mTextureAtlasNode);
 
@@ -116,14 +120,15 @@
 	unsigned int irow = 1;
 	unsigned int icol = 1;
-	unsigned int nrow = Ogre::Math::Sqrt(nextPowerOf2(numSubTextures));
+	unsigned int nrow = Ogre::Math::Sqrt(BBC::Util::nextPowerOf2(numSubTextures));
 	Ogre::Real step = 2.0 / nrow;
 	Ogre::Real degreeStep = 360.0 / numSubTextures;
 	Ogre::Real degree = 0.0;
 
-	IMG::TexturePtr texturePtr ( new IMG::Texture() );
-	texturePtr->bind(mTextureName);
 	Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().create("TextureAtlas" + Ogre::StringConverter::toString(numSubTextures), Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);		
-	materialPtr->getTechnique(0)->getPass(0)->setDiffuse( 1.0, 1.0, 1.0, 0.0);
-	materialPtr->getTechnique(0)->getPass(0)->setAmbient( texturePtr->getAvgColour() );
+	materialPtr->getTechnique(0)->getPass(0)->setAlphaRejectSettings(Ogre::CMPF_GREATER_EQUAL, 10);
+	materialPtr->getTechnique(0)->getPass(0)->createTextureUnitState("transparent.png");
+	materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureFiltering(Ogre::FO_NONE, Ogre::FO_NONE, Ogre::FO_NONE);			
+	materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureAddressingMode(Ogre::TextureUnitState::TAM_CLAMP);
+	materialPtr->getTechnique(0)->getPass(0)->setLightingEnabled(false);
 	mTextureAtlas->setMaterial(materialPtr.getPointer());	
 	mTextureAtlas->setCorners(-1.0, 1.0, 1.0, -1.0);	
@@ -133,12 +138,12 @@
 		IMG::TexturePtr texturePtr = IMG::TexturePtr( new IMG::Texture() );
 		Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().create("TextureAtlas" + Ogre::StringConverter::toString(iSubTexture), Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);		
-		materialPtr->getTechnique(0)->getPass(0)->setAmbient(maxTexCoords[0], maxTexCoords[1], 1.0 );
-		materialPtr->getTechnique(0)->getPass(0)->setDiffuse( 1.0, 1.0, 1.0, 1.0);
+		materialPtr->getTechnique(0)->getPass(0)->setAmbient(Ogre::Math::RangeRandom(1.0, 0.0), 1.0, 0.0);
+		materialPtr->getTechnique(0)->getPass(0)->setDiffuse(1.0, 1.0, 1.0, 1.0);
+		//materialPtr->getTechnique(0)->getPass(0)->setLightingEnabled(false);
 		materialPtr->getTechnique(0)->getPass(0)->setAlphaRejectSettings(Ogre::CMPF_GREATER_EQUAL, 10);
 		materialPtr->getTechnique(0)->getPass(0)->createTextureUnitState(mTextureName, 0);
 		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureFiltering(Ogre::FO_NONE, Ogre::FO_NONE, Ogre::FO_NONE);
 		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureAddressingMode(Ogre::TextureUnitState::TAM_CLAMP);
-		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureRotate(Ogre::Radian(Ogre::Degree(degree)));
-		materialPtr->getTechnique(0)->getPass(0)->setLightingEnabled(false);
+		materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->setTextureRotate(Ogre::Radian(Ogre::Degree(degree)));		
 		
 		texturePtr->setMaterial(materialPtr.getPointer());
